package com.yellowmessenger.flutter_xmpp.sdk.models;

import java.util.List;


public class ChatResponse {
    private Product product;
    private List<Product> products;
    private List<Card> cards;
    private SearchResults searchResults;
    private QuickReplies quickReplies;
    private String message;
    // New Image response
    private String image;
    private String video;

    private Question question;
    private Boolean success;
    private DeepLink deepLink;
    private Boolean typing;
    private Location location;
    private Event event;

    public Location getLocation() {
        return location;
    }

    public void setLocation(Location location) {
        this.location = location;
    }

    public Product getProduct() {
        return product;
    }

    public void setProduct(Product product) {
        this.product = product;
    }

    public SearchResults getSearchResults() {
        return searchResults;
    }

    public void setSearchResults(SearchResults searchResults) {
        this.searchResults = searchResults;
    }

    public List<Product> getProducts() {
        return products;
    }

    public void setProducts(List<Product> products) {
        this.products = products;
    }

    public Question getQuestion() {
        setQuestionFromQuickReplies();
        return question;
    }

    public void setQuestion(Question question) {
        this.question = question;
    }

    public boolean isValid() {
        return getProduct()!=null || getImage() !=null || getVideo() !=null ||getSearchResults()!=null || getQuestion()!=null || getDeepLink()!=null || getEvent()!=null || getQuickReplies() != null || getMessage() != null || getCards() != null;
    }

    public Boolean getSuccess() {
        return success;
    }

    public void setSuccess(Boolean success) {
        this.success = success;
    }

    public DeepLink getDeepLink() {
        return deepLink;
    }

    public void setDeepLink(DeepLink deepLink) {
        this.deepLink = deepLink;
    }

    public Boolean getTyping() {
        return typing;
    }

    public void setTyping(Boolean typing) {
        this.typing = typing;
    }

    public Event getEvent() {
        return event;
    }

    public void setEvent(Event event) {
        this.event = event;
    }

    public QuickReplies getQuickReplies() {
        return quickReplies;
    }

    public void setQuickReplies(QuickReplies quickReplies) {
        this.quickReplies = quickReplies;
    }

    public void setQuestionFromQuickReplies(){
        if(getQuickReplies() != null){
            Question q = new Question();
            q.setQuestion(getQuickReplies().getTitle());
            q.setOptions(getQuickReplies().getOptions());
            setQuestion(q);
        }
    }

    public String getMessage() {
        return message;
    }

//    Added By Priyank
    public String getImage() {
        return image;
    }
    public void setImage(String image) {
        this.image = image;
    }
    public String getVideo() {
        return video;
    }
    public void setVideo(String video) {
        this.video = video;
    }

//End

    public void setMessage(String message) {
        this.message = message;
    }

    public List<Card> getCards() {
        return cards;
    }

    public void setCards(List<Card> cards) {
        this.cards = cards;
    }
}
