import Flutter
import UIKit
import XMPPFramework

public class SwiftFlutterXmppPlugin: NSObject, FlutterPlugin {
    
    var xmppController:XMPPController
   override init() {
   try! self.xmppController = XMPPController(hostName: "xmpp.yellowmssngr.com",
                                        userJIDString: "kishore@xmpp.yellowmssngr.com",
                                        password: "opened")
   }
  let botConfig = BotConfig(bot_id: "", bot_name: "", auth_token: "")
  public static func register(with registrar: FlutterPluginRegistrar) {
    
    let methodChannelName = "com.yellowmessenger.bot/methods"
    let eventChannelName = "com.yellowmessenger.bot/stream"

    let channel = FlutterMethodChannel(name: methodChannelName, binaryMessenger: registrar.messenger())
    let eventChannel = FlutterEventChannel(name: eventChannelName, binaryMessenger: registrar.messenger())
       eventChannel.setStreamHandler(EventStreamHandler())
    let instance = SwiftFlutterXmppPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
    case "initializeXMPP":
        print("Initializing")
        guard let args = call.arguments else {
                     return
                   }
                   if let myArgs = args as? [String: Any],
                      let botId = myArgs["botId"] as? String, let botName = myArgs["botName"] as? String, let authToken = myArgs["authToken"] as? String
                       {
                           print("Config:", botId, botName, authToken)
                           botConfig.setBotConfig(bot_id: botId, bot_name: botName, auth_token: authToken);
                       let connectionStatus = self.xmppController.connect()
                       if (connectionStatus){
                           result("Connected.")
                       }
                   } else {
                     result("iOS could not extract flutter arguments in method: (initializeXMPP)")
                   }
        break
    case "sendData" :
        print("Sending Data")
        let user = XMPPJID(string: "\(botConfig.getBotId())@xmpp.yellowmssngr.com")
        let msg = XMPPMessage(type: "chat", to: user)
        guard let args = call.arguments else {
               return
             }
             if let myArgs = args as? [String: Any],
                let message = myArgs["msg"] as? String {
                msg.addBody(message)
                self.xmppController.xmppStream.send(msg)
                result("Message Sent: \(message)")
             } else {
               result("iOS could not extract flutter arguments in method: (sendData)")
             }
        break
    default:
        result("No Method Configured.")
      
    }
  }
}
class EventStreamHandler: NSObject, FlutterStreamHandler {
    override init() {
        
    }
    

    private var _eventSink: FlutterEventSink?

    func onListen(withArguments arguments: Any?, eventSink events: @escaping FlutterEventSink) -> FlutterError? {
        _eventSink = events
        events("Stream Connected")
        MyBus.shared.myBus().toObservable()
            .subscribe(onNext : {
                events($0)
            })
                    
        return nil
    }

    func onCancel(withArguments arguments: Any?) -> FlutterError? {
        _eventSink = nil
        return nil
    }
   
}

