import 'dart:async';

import 'package:flutter/services.dart';
import 'bot_config.dart';

class FlutterXmpp {
  static const EventChannel _eventChannel = const EventChannel('com.yellowmessenger.bot/stream');
  static const MethodChannel _methodChannel = const MethodChannel('com.yellowmessenger.bot/methods');
  static Stream<String> _botStream;

  static Future<String> sendMessage(String msg) async {
    final String reply = await _methodChannel.invokeMethod('sendData',<String, dynamic>{
      'msg': msg
    });
    return reply;
  }
  static Future<dynamic> initialize(BotConfig myBot) async {
    String ready = await _methodChannel.invokeMethod('initializeXMPP', <String, dynamic>{
      'botId' : myBot.botId,
      'botName' : myBot.botName,
      'authToken' : myBot.authToken

    });
    return ready;
  }
  static Stream<String> get botStream {
    _botStream = _eventChannel.receiveBroadcastStream().map<String>((value) => value);
    return _botStream;
  }

}